#include <stdio.h>
#include <stdlib.h>
#include <setjmp.h>
#include <iocslib.h>
#include <doslib.h>
#include <math.h>
#include <time.h>
#include "complex.h"

#define USAGE "\
3̃WAW`\n\
gp@: julia3 [reMin imMax scLen [scSize [mxCnt [rot_f_limit [Re_A Im_A [Re_B Im_B [Re_C Im_C]]]]]]]\n\
  Newton@̏lɂ reMin=ŏ[-2.0], imMax=ő[2.0], scLen=ӂ̒[4.0]\n\
  scSize=ʃTCY(0c256~256hbg, 1c512~512hbg)[0]\n\
  mxCnt=񐔐(1`65535)[256]\n\
  rot_f_limit=a(Ɣf|f(z)|̏)[0.01]\n\
  Re_A=2̌W̎[0.0], Im_A=2̌W̋[0.0]\n\
  Re_B=1̌W̎[0.0], Im_B=1̌W̋[0.0]\n\
  Re_C=萔̎[-1.0], Im_C=萔̋[0.0]\n\
    f(z)=z^3+A*z^2+B*z+C\n\
"

/* ʃTCỸftHg */
#define SC_SIZE 0

/* vZ͈͂̃ftHg */
#define RE_MIN (-2.0)
#define IM_MAX (2.0)
#define SC_LEN (4.0)

/* ő僋[v񐔂̃ftHg */
#define MX_CNT 256

/* ̐x */
#define ROT_F_LIMIT (0.01)

/* L[`FbN */
#define keysns() \
({ \
  int _k_ = 0; \
  while (B_KEYSNS()) _k_ = B_KEYINP() & 0xff ? : _k_; \
  _k_; \
})

double reMin = RE_MIN, imMax= IM_MAX;
double scLen = SC_LEN;
int scSize = SC_SIZE;
int mxCnt = MX_CNT;
double rot_f_limit = ROT_F_LIMIT;
double rot_f_limit2;

unsigned short *paTable;  /* pbge[u */

void make_palet_table(void);  /* pbge[u */
void init_screen(void);  /* ʂ̏ */
void tini_screen(void);  /* ʂ̌n */

/* Wƒ萔̃ftHg */
#define Re_A (0.0)
#define Im_A (0.0)
#define Re_B (0.0)
#define Im_B (0.0)
#define Re_C (-1.0)
#define Im_C (0.0)

/* Wƒ萔 */
complex A, B, C;

/* f(z),df_f(z)ύX邱Ƃŕʂ̃WAW`Ƃł */
/* f(z)=z^3+A*z^2+B*z+C, df_f(z)=3*z^2+2*A*z+B */
/* }NłƊ֐ł̂ǂ炩I */
#if 0
#define f(z) cadd(cadd(cadd(cpow3(z), cmul(cpow2(z), A)), cmul((z), B)), C)
#define df_f(z) cadd(cadd(cremul(cpow2(z), 3.0), cremul(cmul((z), A), 2.0)), B)
#else
complex f(complex z)
{
  return cadd(cadd(cadd(cpow3(z), cmul(cpow2(z), A)), cmul(z, B)), C);
}
complex df_f(complex z)
{
  return cadd(cadd(cremul(cpow2(z), 3.0), cremul(cmul(z, A), 2.0)), B);
}
#endif

/* lcf(z)ɑ΂Newton@̑Q̔񐔂Ԃ */
int iteration(complex c, int limit_cnt)
{
  complex z;
  int cnt;

  if (setjmp(cjmpenv)) {
    return limit_cnt;  /* vZłȂ */
  }
  cnt = limit_cnt;
  z = c;
  while (cnt > 0 && cabs2(f(z)) > rot_f_limit2) {
    /* f(z)ɑ΂Newton@̑Q rec_f(z)=z-f(z)/df_f(z) */
    z = csub(z, cdiv(f(z), df_f(z)));
    cnt--;
  }
  return limit_cnt - cnt;
}

/* `惋[`̖{ */
void draw_body()
{
  unsigned short *a;
  complex c;
  double step;
  unsigned short scCnt;
  unsigned short reCnt;
  unsigned short imCnt;
  complex c0;

  scCnt = (scSize ? 512 : 256);
  step = scLen / (double)scCnt;

  /* VRAM̏݃AhX */
  a = (unsigned short *)0xc00000;

  c0 = tocomplex(reMin, imMax);

  /* ̃[v */
  for (imCnt = 0; imCnt < scCnt; imCnt++) {
    {
      unsigned short *b;
      b = a;
      /* ꂩ`悷郉X^߂̓_` */
      for (reCnt = 0; reCnt < 512; reCnt += 8) {
	*b = 0xffff;
	b += 8;
      }
    }

    c = c0;

    /* 𑜓xɉĎ̃[vŜ𕪂 */
    if (scSize == 0) {
      /* 256~256hbg */

      /* ̃[v */
      for (reCnt = 0; reCnt < scCnt; reCnt++) {
	unsigned short col;

	/* Q̔񐔂𐔂ăpbge[uQƂ */
	col = paTable[iteration(c, mxCnt)];

	/* 𑜓xɉ傫̓_VRAMɏ */
	*a++ = col;
	*a++ = col;
	a[512-2] = col;
	a[512-1] = col;

	/* ɐi */
	Re(c) += step;
      }
    } else {
      /* 512~512hbg */

      /* ̃[v */
      for (reCnt = 0; reCnt < scCnt; reCnt++) {
	/* Q̔񐔂𐔂ăpbge[uQƂ */
	/* 𑜓xɉ傫̓_VRAMɏ */
	*a++ = paTable[iteration(c, mxCnt)];

	/* ɐi */
	Re(c) += step;
      }
    }

    /* 𑜓xɉVRAM̏݃AhX␳ */
    if (scSize == 0) {
      a += 512;
    }

    /* ɐi */
    Im(c0) -= step;

    /* L[ꂽ璆~ */
    if (keysns()) {
      break;
    }
  }
}

void main(int argc, char *argv[])
{
  clock_t tm0, tm1;

  /* ʂ̏ */
  init_screen();

  /* Wƒ萔̃ftHgݒ */
  A = tocomplex(Re_A, Im_A);
  B = tocomplex(Re_B, Im_B);
  C = tocomplex(Re_C, Im_C);

  /* R}hC̃p[^擾 */
  switch (argc) {
  case 13:
    sscanf(argv[12], "%lf", &Im(C));
    sscanf(argv[11], "%lf", &Re(C));
  case 11:
    sscanf(argv[10], "%lf", &Im(B));
    sscanf(argv[9], "%lf", &Re(B));
  case 9:
    sscanf(argv[8], "%lf", &Im(A));
    sscanf(argv[7], "%lf", &Re(A));
  case 7:
    sscanf(argv[6], "%lf", &rot_f_limit);
  case 6:
    sscanf(argv[5], "%d", &mxCnt);
  case 5:
    sscanf(argv[4], "%d", &scSize);
  case 4:
    sscanf(argv[3], "%lf", &scLen);
    sscanf(argv[2], "%lf", &imMax);
    sscanf(argv[1], "%lf", &reMin);
  case 1:
    break;
  default:
    printf(USAGE);
    return;
  }

  /* a2悵Ă */
  rot_f_limit2 = rot_f_limit * rot_f_limit;

  /* pbge[u */
  make_palet_table();

  /* VRAMɒڏނ߂ɃX[p[oCU[hɂ */
  B_SUPER(0);

  /* vJn */
  {
    clock_t t = clock();
    while ((tm0 = clock()) == t);
  }

  /* `惋[`̖{ */
  draw_body();

  /* vI */
  tm1 = clock();

  /* ʂ̌n */
  tini_screen();

  /* vԂ\ */
  printf("vԂ %.8g błD\n", ((double)(tm1 - tm0)) / CLK_TCK);
}
